package com.dsic.gj_erp.jszb.control;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.excel.EasyExcel;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jhgk.YdjhImportNew;
import com.dsic.gj_erp.jszb.entity.PartFlowInfo;
import com.dsic.gj_erp.jszb.excel.ExcelFlowInfoListener;
import com.dsic.gj_erp.jszb.service.FlowInfoService;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("jszb")
@AllArgsConstructor
public class JszbController {

    private final FlowInfoService flowInfoService;

    @GetMapping("exportJSzb")
    public void exportJSzb(String ch,String begin,String end){

    }

    @GetMapping("getFlowInfoList")
    public ResultBean<?> getFlowInfoList(String ch,String begin,String end) {
        List<PartFlowInfo> list = flowInfoService.list(Wrappers.<PartFlowInfo>lambdaQuery()
                .eq(PartFlowInfo::getCh, ch)
                .eq(StrUtil.isEmpty(end) && StrUtil.isNotEmpty(begin), PartFlowInfo::getFd, begin)
                .between(StrUtil.isAllNotEmpty(begin, end), PartFlowInfo::getFd, begin, end)
        );
        return new ResultBean<>(list);
    }

    @PostMapping("importFLowInfo")
    public ResultBean<?> importFLowInfo(@RequestParam("file") MultipartFile file) throws IOException {
        ExcelFlowInfoListener objectListener = new ExcelFlowInfoListener();
        EasyExcel.read(file.getInputStream(), PartFlowInfo.class, objectListener).sheet(0).headRowNumber(1).doRead();
        List<PartFlowInfo> objList = objectListener.getObjectList();
        List<PartFlowInfo> updateList=new ArrayList<>();
        objList.forEach(item->{
            PartFlowInfo one=null;
            if (StrUtil.isNotEmpty(item.getCh())){
                one = flowInfoService.getOne(Wrappers.<PartFlowInfo>lambdaQuery()
                        .and(it->it.eq(PartFlowInfo::getCh, item.getCh())
                                .or(it0->it0.eq(PartFlowInfo::getCh, item.getProject())))
                        .and(it->it.eq(PartFlowInfo::getPartName, item.getPartName())
                                .or(it0->it0.eq(PartFlowInfo::getPartName, item.getPartName0()))
                ));
            }

            if (StrUtil.isNotEmpty(item.getProject())){
                one = flowInfoService.getOne(Wrappers.<PartFlowInfo>lambdaQuery()
                        .eq(PartFlowInfo::getCh, item.getCh())
                        .eq(PartFlowInfo::getPartName, item.getPartName())
                );
            }

            if (one==null){
                one = new PartFlowInfo();
            }

            BeanUtil.copyProperties(item,one);

            if(item.getProject()!=null){
                one.setCh(item.getProject());
                one.setPartName(item.getPartName0());
            }

            updateList.add(one);
        });

        flowInfoService.saveOrUpdateBatch(updateList);
        return new ResultBean<>();
    }

}
